

//	This source and ASCII Text File Context Build method apply to GNU General Public License. 
//			Copyright (C) 2007,2008,2009,2010  Jasenko Dzinleski 

//		This program is free software; you can redistribute it
//	and/or modify it under the terms of the GNU General Public License as
//	published by the Free Software Foundation; either version 2 of the
//	License, or (at your option) any later version. 

//	This program is distributed in the hope that it will be useful, but
//	WITHOUT ANY WARRANTY; without even the implied warranty of
//	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
//	General Public License for more details. 

//	You should have received a copy of the GNU General Public License along
//	with this program; if not, write to the Free Software Foundation, Inc.,
//	51 Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA.

//
//			ASCII Text File Context Build Routine
//			written by Dzinleski Jasenko Febrary,2007 - 2013
//


#include 	<stdio.h>
#include 	<string.h>

#define		buffL		1024
#define		tokBound0	0
#define		tokBound1	15
#define		tokBound2	20
#define		tokLen		5
#define		tokIfL		16
#define		maxDtok		60000

//char 		in1fn[256]="book_sd.txt";
//char 		in1fn[256]="a.exe";
//char 		in1fn[256]="compaq.txt";
//char 		in1fn[256]="iminja.txt";
//char 		in1fn[256]="m03_2.bmp";
//char 		in1fn[256]="t_.jpg";

char 		in1fn[256];
char 		out1fn[256]="Dictionary.txt";

FILE	*f1,*f2;

char		c_l[256]="{[--]}{[hh][ll][vv][ff]}{[AZ][az][09][__][  ][..][\'\'][\"\"]}";

int			li[buffL][3];				int	lii=0;
int			sc[buffL][2];				int sci=0;

bool		bt32_1[32];					int	bt32i_1=0;
bool		bt32_2[32];					int	bt32i_2=0;

bool		br[256*8];					int	bri=0;

__int64		bc=0,fbc=0;
bool		df=false;
bool		df_seg=false;
bool		df_ver=false;

int			tc[256];					int	tci=0;
int			tt[256];					int	tti=0;

int			nb[buffL][2];				int	nbi=0;
long		tn[maxDtok][tokIfL];			int	tni=0;
long		tr[tokIfL];					int	tri=0;




int	c_p(char cl_a[256],int ci,bool tf,char r_a[256])
{

	int		a,b,c,d=0;
	
	for(a=0;a<256;++a){r_a[a]='\0';}

	if(tf)
	{
		for(a=0;a<strlen(c_l);++a){
			if(cl_a[a]=='{'){++d;for(b=a+1;b<strlen(cl_a);++b){if(cl_a[b]=='}'){if(d==ci){break;}}}}
			if(b!=strlen(cl_a)){break;}
		}
	}else{
		for(a=0;a<strlen(cl_a);++a){
			if(cl_a[a]=='['){++d;for(b=a+1;b<strlen(cl_a);++b){if(cl_a[b]==']'){if(d==ci){break;}}}}
			if(b!=strlen(cl_a)){break;}
		}
	}

	d=0;for(c=a+1;c<b;++c){r_a[d]=cl_a[c];++d;/*printf("%c",cl_a[c]);*/}

	return(0);

}

int pr32_(long d,bool b_[32],int b_i)
{

	b_i=0;
	if((((((d&0xff000000)>>24)<<24)>>31)&0x1)==1){b_[b_i]=true;++b_i;}else{b_[b_i]=false;++b_i;}
	if((((((d&0xff000000)>>24)<<25)>>31)&0x1)==1){b_[b_i]=true;++b_i;}else{b_[b_i]=false;++b_i;}
	if((((((d&0xff000000)>>24)<<26)>>31)&0x1)==1){b_[b_i]=true;++b_i;}else{b_[b_i]=false;++b_i;}
	if((((((d&0xff000000)>>24)<<27)>>31)&0x1)==1){b_[b_i]=true;++b_i;}else{b_[b_i]=false;++b_i;}
	if((((((d&0xff000000)>>24)<<28)>>31)&0x1)==1){b_[b_i]=true;++b_i;}else{b_[b_i]=false;++b_i;}
	if((((((d&0xff000000)>>24)<<29)>>31)&0x1)==1){b_[b_i]=true;++b_i;}else{b_[b_i]=false;++b_i;}
	if((((((d&0xff000000)>>24)<<30)>>31)&0x1)==1){b_[b_i]=true;++b_i;}else{b_[b_i]=false;++b_i;}
	if((((((d&0xff000000)>>24)<<31)>>31)&0x1)==1){b_[b_i]=true;++b_i;}else{b_[b_i]=false;++b_i;}

	if((((((d&0x00ff0000)>>16)<<24)>>31)&0x1)==1){b_[b_i]=true;++b_i;}else{b_[b_i]=false;++b_i;}
	if((((((d&0x00ff0000)>>16)<<25)>>31)&0x1)==1){b_[b_i]=true;++b_i;}else{b_[b_i]=false;++b_i;}
	if((((((d&0x00ff0000)>>16)<<26)>>31)&0x1)==1){b_[b_i]=true;++b_i;}else{b_[b_i]=false;++b_i;}
	if((((((d&0x00ff0000)>>16)<<27)>>31)&0x1)==1){b_[b_i]=true;++b_i;}else{b_[b_i]=false;++b_i;}
	if((((((d&0x00ff0000)>>16)<<28)>>31)&0x1)==1){b_[b_i]=true;++b_i;}else{b_[b_i]=false;++b_i;}
	if((((((d&0x00ff0000)>>16)<<29)>>31)&0x1)==1){b_[b_i]=true;++b_i;}else{b_[b_i]=false;++b_i;}
	if((((((d&0x00ff0000)>>16)<<30)>>31)&0x1)==1){b_[b_i]=true;++b_i;}else{b_[b_i]=false;++b_i;}
	if((((((d&0x00ff0000)>>16)<<31)>>31)&0x1)==1){b_[b_i]=true;++b_i;}else{b_[b_i]=false;++b_i;}

	if((((((d&0x0000ff00)>>8)<<24)>>31)&0x1)==1){b_[b_i]=true;++b_i;}else{b_[b_i]=false;++b_i;}
	if((((((d&0x0000ff00)>>8)<<25)>>31)&0x1)==1){b_[b_i]=true;++b_i;}else{b_[b_i]=false;++b_i;}
	if((((((d&0x0000ff00)>>8)<<26)>>31)&0x1)==1){b_[b_i]=true;++b_i;}else{b_[b_i]=false;++b_i;}
	if((((((d&0x0000ff00)>>8)<<27)>>31)&0x1)==1){b_[b_i]=true;++b_i;}else{b_[b_i]=false;++b_i;}
	if((((((d&0x0000ff00)>>8)<<28)>>31)&0x1)==1){b_[b_i]=true;++b_i;}else{b_[b_i]=false;++b_i;}
	if((((((d&0x0000ff00)>>8)<<29)>>31)&0x1)==1){b_[b_i]=true;++b_i;}else{b_[b_i]=false;++b_i;}
	if((((((d&0x0000ff00)>>8)<<30)>>31)&0x1)==1){b_[b_i]=true;++b_i;}else{b_[b_i]=false;++b_i;}
	if((((((d&0x0000ff00)>>8)<<31)>>31)&0x1)==1){b_[b_i]=true;++b_i;}else{b_[b_i]=false;++b_i;}

	if(((((d&0x000000ff)<<24)>>31)&0x1)==1){b_[b_i]=true;++b_i;}else{b_[b_i]=false;++b_i;}
	if(((((d&0x000000ff)<<25)>>31)&0x1)==1){b_[b_i]=true;++b_i;}else{b_[b_i]=false;++b_i;}
	if(((((d&0x000000ff)<<26)>>31)&0x1)==1){b_[b_i]=true;++b_i;}else{b_[b_i]=false;++b_i;}
	if(((((d&0x000000ff)<<27)>>31)&0x1)==1){b_[b_i]=true;++b_i;}else{b_[b_i]=false;++b_i;}
	if(((((d&0x000000ff)<<28)>>31)&0x1)==1){b_[b_i]=true;++b_i;}else{b_[b_i]=false;++b_i;}
	if(((((d&0x000000ff)<<29)>>31)&0x1)==1){b_[b_i]=true;++b_i;}else{b_[b_i]=false;++b_i;}
	if(((((d&0x000000ff)<<30)>>31)&0x1)==1){b_[b_i]=true;++b_i;}else{b_[b_i]=false;++b_i;}
	if(((((d&0x000000ff)<<31)>>31)&0x1)==1){b_[b_i]=true;++b_i;}else{b_[b_i]=false;++b_i;}

	return(b_i);
}

long p_1(long spos)
{

	int		b8o,b8e,b16o,b16e;
	int		nH,nL;
	int		i,j,k,l,m,n,p,q,r,s;
	int		a,b,c,c1,c2,d,e;
	int		mx,mn,mni,mxi;

	int		p1,p2,p3,p4,p5;

	int		l1,l2,l3,l4,l5;
	int		b1,b2,b3,b4,b5,b6;

	bool	ef=false;

	b8o=0;
	b8o|=1<<0;
	b8o|=1<<2;
	b8o|=1<<4;
	b8o|=1<<6;

	b8e=0;
	b8e|=1<<1;
	b8e|=1<<3;
	b8e|=1<<5;
	b8e|=1<<7;

	b16o=0;
	b16o|=1<<0;
	b16o|=1<<2;
	b16o|=1<<4;
	b16o|=1<<6;
	b16o|=1<<8;
	b16o|=1<<10;
	b16o|=1<<12;
	b16o|=1<<14;

	b16e=0;
	b16e|=1<<1;
	b16e|=1<<3;
	b16e|=1<<5;
	b16e|=1<<7;
	b16e|=1<<9;
	b16e|=1<<11;
	b16e|=1<<13;
	b16e|=1<<15;

	s=0;sci=0;
	while(s<=0xff)
	{

		lii=0;fbc=0;
		f1=fopen(in1fn,"rb");
		fseek(f1,spos,SEEK_SET);
	
		while(!feof(f1)&&fbc<(buffL*8))
		{

			a=getc(f1);fbc+=8;
			if(a<=s){li[lii][0]=a;++lii;}

		}if(feof(f1)){spos=-1;}

		mn=-1;for(i=0;i<lii;++i){if(mn==-1){mn=li[i][0];}else{if(mn>li[i][0]){mn=li[i][0];}}}
		mx=-1;for(i=0;i<lii;++i){if(mx==-1){mx=li[i][0];}else{if(mx<li[i][0]){mx=li[i][0];}}}
		//printf(".%03d %03d\n",mn,mx);
		for(i=0;i<lii;++i)
		{
			li[i][1]=((((b8e&(mn<<1))>>1)^((b8e&((li[i][0]&0xff)<<1))>>1))<<1)|((b8o&mn)^(b8o&((li[i][0]&0xff)<<1)));	
			li[i][2]=((((b8e&(mx<<1))>>1)^((b8e&((li[i][0]&0xff)<<1))>>1))<<1)|((b8o&mx)^(b8o&((li[i][0]&0xff)<<1)));	
		}

		if(df){printf("cnt.%03d.\n",lii);}

		mn=-1;mni=-1;for(i=0;i<lii;++i){if(mn==-1){mn=li[i][1];}else{if(mn>li[i][1]){mni=i;mn=li[i][1];}}}
		mx=-1;mxi=-1;for(i=0;i<lii;++i){if(mx==-1){mx=li[i][1];}else{if(mx<li[i][1]){mxi=i;mx=li[i][1];}}}
		//printf(".%03d %03d %03d %03d %c %c.\n",mn,mx,li[mni][0],li[mxi][0],(char)li[mni][0],(char)li[mxi][0]);
		if(df)
		{
			if(mni!=-1){printf("min.%03d %03d.",mn,li[mni][0]);}
			if(mxi!=-1){printf("max.%03d %03d.\n",mx,li[mxi][0]);}
		}

		mn=-1;mni=-1;for(i=0;i<lii;++i){if(mn==-1){mn=li[i][2];}else{if(mn>li[i][2]){mni=i;mn=li[i][2];}}}
		mx=-1;mxi=-1;for(i=0;i<lii;++i){if(mx==-1){mx=li[i][2];}else{if(mx<li[i][2]){mxi=i;mx=li[i][2];}}}
		//printf(".%03d %03d %03d %03d %c %c.\n",mn,mx,li[mni][0],li[mxi][0],(char)li[mni][0],(char)li[mxi][0]);
		if(df)
		{
			if(mni!=-1){printf("min.%03d %03d.",mn,li[mni][0]);}
			if(mxi!=-1){printf("max.%03d %03d.\n",mx,li[mxi][0]);}
		}

		sc[sci][0]=lii;
		sc[sci][1]=s;
		++sci;

		fclose(f1);

		s+=2;

	}

	//printf("\n");
	mn=-1;mni=-1;for(i=0;i<sci;++i){if(mn==-1){mn=sc[i][0];}else{if(mn>sc[i][0]){mni=i;mn=sc[i][0];}}}
	mx=-1;mxi=-1;for(i=0;i<sci;++i){if(mx==-1){mx=sc[i][0];}else{if(mx<sc[i][0]){mxi=i;mx=sc[i][0];}}}
	//printf(".%03d %03d %03d %03d %c %c.\n",mn,mx,li[mni][0],li[mxi][0],(char)li[mni][0],(char)li[mxi][0]);
	if(df)
	{
		if(mni!=-1){printf("min.%03d %03d.",sc[mni][0],sc[mni][1]);}
		if(mxi!=-1){printf("max.%03d %03d.\n",sc[mxi][0],sc[mxi][1]);}
	}
	//printf(".%03d %03d\n",mn,mx);
	//printf("\n");
	c=-1;d=0;nbi=0;
	for(i=0;i<sci;++i)
	{
		a=((((b16e&(mn<<1))>>1)^((b16e&((sc[i][0]&0xffff)<<1))>>1))<<1)|((b16o&mn)^(b8o&((sc[i][0]&0xffff)<<1)));	
		b=((((b16e&(mx<<1))>>1)^((b16e&((sc[i][0]&0xffff)<<1))>>1))<<1)|((b16o&mx)^(b8o&((sc[i][0]&0xffff)<<1)));	
		if(c==-1)
		{
			//printf(".%05d %05d n<= %05d %05d %05d + %05d\n",a,b,sc[i][1],sc[i][0],d,sc[i][0]-d);
			if(df_seg){printf(" n<= %05d %05d %05d + %05d\n",sc[i][1],sc[i][0],d,sc[i][0]-d);}
			
			nb[nbi][0]=sc[i][1];
			nb[nbi][1]=sc[i][0]-d;
			++nbi;

			c=a;d=sc[i][0];
		}else{
				if(c!=a)
				{
					//printf(".%05d %05d n<= %05d %05d %05d + %05d\n",a,b,sc[i][1],sc[i][0],d,sc[i][0]-d);
					if(df_seg){printf(" n<= %05d %05d %05d + %05d\n",sc[i][1],sc[i][0],d,sc[i][0]-d);}
					
					nb[nbi][0]=sc[i][1];
					nb[nbi][1]=sc[i][0]-d;
					++nbi;

					c=a;d=sc[i][0];
				}
		}
	}

	return(spos);

}

int main(int argc,char *argv[])
{

	int			i,j,k,l,m,n,p,t=-1;
	int			a,b,c;

	long		pos=0;

	char		cmd[50][256];
	char		c_1[256];
	char		c_2[256];
	int			ci;

	char		fn[10][2];int	fi=0;
	int			op=0;

	for(i=0;i<50;++i){for(j=0;j<256;++j){cmd[i][j]='\0';}}
	for(i=0;i<argc;++i){strcpy(cmd[i],argv[i]);}

	printf("\nASCII Text File Context Build\n");
	printf("written by Dzinleski Jasenko February,2007 - 2013\n");
	printf("\nOS Win32 VRM 2.1.0\n\n");

	//|	-
	ci=1;
	for(i=0;i<256;++i){c_1[i]='\0';}
	c_p(c_l,ci,true,c_1);
	//for(i=0;i<strlen(c_1);++i){printf("%c",c_1[i]);}

	ci=1;
	for(i=0;i<256;++i){c_2[i]='\0';}
	c_p(c_1,ci,false,c_2);
	//for(i=0;i<strlen(c_2);++i){printf("%c",c_2[i]);}

	if(cmd[1][0]==c_2[0]||cmd[1][0]==c_2[1]){}else{return(0);}
	//|

	//|	h, l, v, f 
	ci=2;
	for(i=0;i<256;++i){c_1[i]='\0';}
	c_p(c_l,ci,true,c_1);
	//for(i=0;i<strlen(c_1);++i){printf("%c",c_1[i]);}

	ci=1;
	for(i=0;i<256;++i){c_2[i]='\0';}
	c_p(c_1,ci,false,c_2);
	//for(i=0;i<strlen(c_2);++i){printf("%c",c_2[i]);}

	if(cmd[1][1]==c_2[0]||cmd[1][1]==c_2[1]){op=1;/*printf("h");*/}

	ci=2;
	for(i=0;i<256;++i){c_2[i]='\0';}
	c_p(c_1,ci,false,c_2);
	//for(i=0;i<strlen(c_2);++i){printf("%c",c_2[i]);}

	if(cmd[1][1]==c_2[0]||cmd[1][1]==c_2[1]){op=2;/*printf("l");*/}

	ci=3;
	for(i=0;i<256;++i){c_2[i]='\0';}
	c_p(c_1,ci,false,c_2);
	//for(i=0;i<strlen(c_2);++i){printf("%c",c_2[i]);}

	if(cmd[1][1]==c_2[0]||cmd[1][1]==c_2[1]){df_ver=true;/*printf("v");*/}

	ci=4;
	for(i=0;i<256;++i){c_2[i]='\0';}
	c_p(c_1,ci,false,c_2);
	//for(i=0;i<strlen(c_2);++i){printf("%c",c_2[i]);}

	if((cmd[1][1]==c_2[0]||cmd[1][1]==c_2[1])||(cmd[2][1]==c_2[0]||cmd[2][2]==c_2[1])){op=3;/*printf("f");*/}

	if(!(op==1||op==2||op==3)){return(0);}else{


 		if(op==1)
		{

			//printf("\tThis source and ASCII Text File Context Build method apply to GNU General Public License. \n");
			//printf("\t	Copyright (C) 2007,2008,2009,2010  Jasenko Dzinleski \n");
			//printf("\n");

			printf("dp_13_201_1 -f <filename>\n");
			printf("\n");

			return(0);

		}

		if(op==2)
		{

			printf("\tThis source and ASCII Text File Context Build method apply to GNU General Public License. \n");
			printf("\t	Copyright (C) 2007-2013  Jasenko Dzinleski \n");
			printf("\n");
			printf("\t	This program is free software; you can redistribute it\n");
			printf("\tand/or modify it under the terms of the GNU General Public License as\n");
			printf("\tpublished by the Free Software Foundation; either version 2 of the\n");
			printf("\tLicense, or (at your option) any later version.\n");
			printf("\n");
			printf("\tThis program is distributed in the hope that it will be useful, but\n");
			printf("\tWITHOUT ANY WARRANTY; without even the implied warranty of\n");
			printf("\tMERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU\n");
			printf("\tGeneral Public License for more details.\n");
			printf("\n");
			printf("\tYou should have received a copy of the GNU General Public License along\n");
			printf("\twith this program; if not, write to the Free Software Foundation, Inc.,\n");
			printf("\t51 Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA.\n");
			printf("\n"); 			
			
			return(0);

		}

		if(op==3)
		{

		//|	<filename>
		ci=3;
		for(i=0;i<256;++i){c_1[i]='\0';}
		c_p(c_l,ci,true,c_1);
		//for(i=0;i<strlen(c_1);++i){printf("%c",c_1[i]);}

		ci=1;
		for(i=0;i<256;++i){c_2[i]='\0';}
		c_p(c_1,ci,false,c_2);
		//for(i=0;i<strlen(c_2);++i){printf("%c",c_2[i]);}

		fn[fi][0]=c_2[0];fn[fi][1]=c_2[1];++fi;

		ci=2;
		for(i=0;i<256;++i){c_2[i]='\0';}
		c_p(c_1,ci,false,c_2);
		//for(i=0;i<strlen(c_2);++i){printf("%c",c_2[i]);}

		fn[fi][0]=c_2[0];fn[fi][1]=c_2[1];++fi;

		ci=3;
		for(i=0;i<256;++i){c_2[i]='\0';}
		c_p(c_1,ci,false,c_2);
		//for(i=0;i<strlen(c_2);++i){printf("%c",c_2[i]);}

		fn[fi][0]=c_2[0];fn[fi][1]=c_2[1];++fi;

		ci=4;
		for(i=0;i<256;++i){c_2[i]='\0';}
		c_p(c_1,ci,false,c_2);
		//for(i=0;i<strlen(c_2);++i){printf("%c",c_2[i]);}

		fn[fi][0]=c_2[0];fn[fi][1]=c_2[1];++fi;

		ci=5;
		for(i=0;i<256;++i){c_2[i]='\0';}
		c_p(c_1,ci,false,c_2);
		//for(i=0;i<strlen(c_2);++i){printf("%c",c_2[i]);}

		fn[fi][0]=c_2[0];fn[fi][1]=c_2[1];++fi;

		ci=6;
		for(i=0;i<256;++i){c_2[i]='\0';}
		c_p(c_1,ci,false,c_2);
		//for(i=0;i<strlen(c_2);++i){printf("%c",c_2[i]);}

		fn[fi][0]=c_2[0];fn[fi][1]=c_2[1];++fi;

		ci=7;
		for(i=0;i<256;++i){c_2[i]='\0';}
		c_p(c_1,ci,false,c_2);
		//for(i=0;i<strlen(c_2);++i){printf("%c",c_2[i]);}

		fn[fi][0]=c_2[0];fn[fi][1]=c_2[1];++fi;

		ci=8;
		for(i=0;i<256;++i){c_2[i]='\0';}
		c_p(c_1,ci,false,c_2);
		//for(i=0;i<strlen(c_2);++i){printf("%c",c_2[i]);}

		fn[fi][0]=c_2[0];fn[fi][1]=c_2[1];++fi;

		if(df_ver){j=3;}else{j=2;}
		for(i=0;i<strlen(cmd[j]);++i)
		{
			if
				(
				(cmd[j][i]>=fn[0][0]&&cmd[j][i]<=fn[0][1])||
				(cmd[j][i]>=fn[1][0]&&cmd[j][i]<=fn[1][1])||
				(cmd[j][i]>=fn[2][0]&&cmd[j][i]<=fn[2][1])||
				(cmd[j][i]>=fn[3][0]&&cmd[j][i]<=fn[3][1])||
				(cmd[j][i]>=fn[4][0]&&cmd[j][i]<=fn[4][1])||
				(cmd[j][i]>=fn[5][0]&&cmd[j][i]<=fn[5][1])||
				(cmd[j][i]>=fn[6][0]&&cmd[j][i]<=fn[6][1])||
				(cmd[j][i]>=fn[7][0]&&cmd[j][i]<=fn[7][1])||
				(cmd[j][i]>=fn[8][0]&&cmd[j][i]<=fn[8][1])
				){}else{break;}
		}
		if(i==strlen(cmd[j])){/*printf("?");*/}else{return(0);}
		//|
		}
	}

	if(argv[1]!=NULL){strcpy(in1fn,cmd[j]);f1=fopen(in1fn,"rb");if(f1==NULL){return(0);}}else{fclose(f1);return(0);}

	for(i=0;i<256;++i){tt[i]=0;}tti=0;
	f2=fopen(out1fn,"wb");
	for(i=0;i<maxDtok;++i){for(j=0;j<tokIfL;++j){tn[i][j]=0;}}tni=0;
		
	while(p_1(pos)!=-1)
	{
		//for(i=0;i<nbi;++i){printf(".%d %d.",nb[i][0],nb[i][1]);}

		for(i=0;i<nbi;++i)
		{
			for(j=0;j<nbi;++j)
			{
				if(nb[i][1]>nb[j][1])
				{
					a=nb[j][0];
					b=nb[j][1];
					nb[j][0]=nb[i][0];
					nb[j][1]=nb[i][1];
					nb[i][0]=a;
					nb[i][1]=b;
				}
			}
		}

		//for(i=0;i<nbi;++i){printf("%d %d\n",nb[i][0],nb[i][1]);}

		f1=fopen(in1fn,"rb");
		fseek(f1,pos,SEEK_SET);
		fbc=0;for(i=0;i<256;++i){tc[i]=0;}tci=0;
		c=getc(f1);fbc+=8;
		while(!feof(f1)&&fbc<(buffL*8))
		{
			if(!((c==32)||(c==10)||(c==13)))
			{	

				a=0;for(i=0;i<-1+nbi;++i){++a;if(a>(nbi-10)){break;}if(c<=nb[i][0]&&c>=nb[i+1][0]){break;}}
				if(a>=tokBound0&&a<tokBound1){tc[tci]=c;++tci;++b;/*printf("%c",(char)c);*/}else{
					if(a>=tokBound1&&a<tokBound2){/*tc[tci]='_';*/tc[tci]=c;++tci;++b;}else{b=0;for(i=0;i<256;++i){tc[i]=0;}tci=0;}
				}

			}else{

				if(b>=tokLen)
				{

					if(df_ver){for(i=0;i<tci;++i){printf("%c",(char)tc[i]);}printf("\n");}
					for(i=0;i<256;++i){tt[i]=0;}tti=0;for(i=0;i<tci;++i){tt[tti]=tc[i];++tti;}

					bri=0;
					for(i=0;i<tci;++i)
					{
						pr32_(tc[i] ,bt32_1,bt32i_1);
						p=32;for(a=0;a<32;++a){if(bt32_1[a]){p=a;break;}}for(a=p;a<32;++a){br[bri]=bt32_1[a];++bri;}
					}/*printf(".%d.",bri);*/

					a=1;c=24;for(i=0;i<tokIfL;++i){tr[i]=0;}tri=0;
					while(a*8<=bri)
					{
						j=0;l=7;i=((a*8)-8);
						if(i  <(a*8)){if(br[i]  ){j|=1<<l;}--l;}
						if(i+1<(a*8)){if(br[++i]){j|=1<<l;}--l;}
						if(i+1<(a*8)){if(br[++i]){j|=1<<l;}--l;}
						if(i+1<(a*8)){if(br[++i]){j|=1<<l;}--l;}
						if(i+1<(a*8)){if(br[++i]){j|=1<<l;}--l;}
						if(i+1<(a*8)){if(br[++i]){j|=1<<l;}--l;}
						if(i+1<(a*8)){if(br[++i]){j|=1<<l;}--l;}
						if(i+1<(a*8)){if(br[++i]){j|=1<<l;}--l;}
						/*printf(".%d.",j);*/
						if(c==24){tr[tri]=(j<<c);}else{tr[tri]|=(j<<c);}
						c-=8;if(c<0){c=24;++tri;}
						++a;

					}if(c!=24){++tri;}//printf(".%d.\n",tri);
					/*for(i=0;i<tri;++i){printf(".%d.",tr[i]);}*/
					if(tni==0)
					{
						j=0;for(i=0;i<tri;++i){tn[tni][j]=tr[i];++j;}++tni;
						if(tni>=maxDtok)
						{
							printf("\n%d Entries written into Dictionary.txt\n",tni);
							printf("\nDictionary overflow... \nExiting at source file offset %d\n",ftell(f1));
							fclose(f1);fclose(f2);
							return(0);
						}
					}else{

						for(i=0;i<tni;++i){for(j=0;j<tri;++j){if(tn[i][j]!=tr[j]){break;}}if(j==tri){break;}}
						if(i==tni)
						{
							for(j=0;j<tri;++j){tn[tni][j]=tr[j];}++tni;
							if(tni>=maxDtok)
							{
								printf("\n%d Entries written into Dictionary.txt\n",tni);
								printf("\nDictionary overflow... \nExiting at source file offset %d\n",ftell(f1));
								fclose(f1);fclose(f2);
								return(0);
							}
						}//else{printf("!!!!!!!!!!!!!!!\n");}

					}if(df_ver){printf(".%d.",tni);}
					if(t==-1)
					{
						for(i=0;i<tci;++i){fprintf(f2,"%c",(char)tc[i]);}fprintf(f2,"%c%c",(char)13,(char)10);
						t=tni;
					}else{
						if(t!=tni)
						{
							for(i=0;i<tti;++i){fprintf(f2,"%c",(char)tt[i]);}fprintf(f2,"%c%c",(char)13,(char)10);
							t=tni;
						}
					}
				}

				b=0;for(i=0;i<256;++i){tc[i]=0;}tci=0;
			}

			c=getc(f1);fbc+=8;
		}
		fclose(f1);

		pos+=1024;


	}
	fclose(f2);

	printf("\n%d Entries written into Dictionary.txt\n",tni);

	return(0);

}

